//
//      Calculator.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.0.
//

#include "Calculator.hpp"
#include "Monitor.hpp"
#include "Cursor.hpp"
#include "Expression.hpp"
#include "Sangi.hpp"
#include "SuperMath.hpp"

#define FLOATTOSTR_BUFSIZE 20
#define EXPRESSION_THRESHOLD  -4    // w\ꍇƂ̂܂ܕ\\ꍇ̋̃I[_[

template <typename Tsou, typename Tdes>
inline UInt64 UInt64Cast(UInt64 val)
{
    Tsou source(static_cast<Tsou>(val));
    Tdes destination(static_cast<Tdes>(source));
    return static_cast<UInt64>(destination);
}

inline Float64 UInt64ToFloat64(UInt64 x)
{
#if defined(TARGET_COMPILER_ARMCPP) || defined(TARGET_COMPILER_GNUCPP)
    return static_cast<Float64>(x);
#else
    return static_cast<Float64>(static_cast<UInt32>(x >> 32)) * 4294967296.0 + static_cast<Float64>(static_cast<UInt32>(x & 0xFFFFFFFF));
#endif
}

Calculator::Calculator(MonitorPtr monitor) : _monitor(monitor), _number(NUMBERTYPE_DEC), _sign(SIGNTYPE_S), _bit(BITTYPE_64), _angle(ANGLETYPE_RAD)
{
    return;
}

Calculator::~Calculator(Void)
{
    return;
}

Void Calculator::SetNumberType(NumberTypeEnum param)
{
    SFXAnsiString str(_monitor->GetAnswer());

    if (!str.IsEmptyCString() && _number != param) {
        if (_number != NUMBERTYPE_DEC && param == NUMBERTYPE_DEC) {
            _ansOct = ANSOCT_OCT;
        }
        else if (_number == NUMBERTYPE_DEC && param != NUMBERTYPE_DEC) {
            _lastAnsReal = UInt64ToFloat64(_lastAnsInt);
        }
        _monitor->SetAnswer(UInt64ToAnswer(_lastAnsInt, _sign, _bit, param));
    }
    _number = param;
    _monitor->SetNumberType(_number);
    SetSignType(SIGNTYPE_S);
    SetBitType(BITTYPE_64);
    return;
}

Void Calculator::SetSignType(SignTypeEnum param)
{
    SFXAnsiString str(_monitor->GetAnswer());
    if (!str.IsEmptyCString() && _sign != param) {
        switch (_bit) {
            case BITTYPE_08:
                if (param == SIGNTYPE_U) {
                    _lastAnsInt = UInt64Cast<SInt08, UInt08>(_lastAnsInt);
                }
                else {
                    _lastAnsInt = UInt64Cast<UInt08, SInt08>(_lastAnsInt);
                }
                break;
            case BITTYPE_16:
                if (param == SIGNTYPE_U) {
                    _lastAnsInt = UInt64Cast<SInt16, UInt16>(_lastAnsInt);
                }
                else {
                    _lastAnsInt = UInt64Cast<UInt16, SInt16>(_lastAnsInt);
                }
                break;
            case BITTYPE_32:
                if (param == SIGNTYPE_U) {
                    _lastAnsInt = UInt64Cast<SInt32, UInt32>(_lastAnsInt);
                }
                else {
                    _lastAnsInt = UInt64Cast<UInt32, SInt32>(_lastAnsInt);
                }
                break;
        }
        _lastAnsReal = UInt64ToFloat64(_lastAnsInt);
        _monitor->SetAnswer(UInt64ToAnswer(_lastAnsInt, param, _bit, _number));
    }
    _sign = param;
    _monitor->SetSignType(_sign);
    return;
}

Void Calculator::SetBitType(BitTypeEnum param)
{
    SFXAnsiString str(_monitor->GetAnswer());

    if (!str.IsEmptyCString() && _bit != param) {
        if (_sign == SIGNTYPE_U) {
            switch (_bit) {
                case BITTYPE_08:
                    switch (param) {
                        case BITTYPE_16:
                            _lastAnsInt = UInt64Cast<UInt08, UInt16>(_lastAnsInt);
                            break;
                        case BITTYPE_32:
                            _lastAnsInt = UInt64Cast<UInt08, UInt32>(_lastAnsInt);
                            break;
                        case BITTYPE_64:
                            _lastAnsInt = UInt64Cast<UInt08, UInt64>(_lastAnsInt);
                            break;
                    }
                    break;
                case BITTYPE_16:
                    switch (param) {
                        case BITTYPE_08:
                            _lastAnsInt = UInt64Cast<UInt16, UInt08>(_lastAnsInt);
                            break;
                        case BITTYPE_32:
                            _lastAnsInt = UInt64Cast<UInt16, UInt32>(_lastAnsInt);
                            break;
                        case BITTYPE_64:
                            _lastAnsInt = UInt64Cast<UInt16, UInt64>(_lastAnsInt);
                            break;
                    }
                    break;
                case BITTYPE_32:
                    switch (param) {
                        case BITTYPE_08:
                            _lastAnsInt = UInt64Cast<UInt32, UInt08>(_lastAnsInt);
                            break;
                        case BITTYPE_16:
                            _lastAnsInt = UInt64Cast<UInt32, UInt16>(_lastAnsInt);
                            break;
                        case BITTYPE_64:
                            _lastAnsInt = UInt64Cast<UInt32, UInt64>(_lastAnsInt);
                            break;
                    }
                    break;
                case BITTYPE_64:
                    switch (param) {
                        case BITTYPE_08:
                            _lastAnsInt = UInt64Cast<UInt64, UInt08>(_lastAnsInt);
                            break;
                        case BITTYPE_16:
                            _lastAnsInt = UInt64Cast<UInt64, UInt16>(_lastAnsInt);
                            break;
                        case BITTYPE_32:
                            _lastAnsInt = UInt64Cast<UInt64, UInt32>(_lastAnsInt);
                            break;
                    }
                    break;
            }
        }
        else {
            switch (_bit) {
                case BITTYPE_08:
                    switch (param) {
                        case BITTYPE_16:
                            _lastAnsInt = UInt64Cast<SInt08, SInt16>(_lastAnsInt);
                            break;
                        case BITTYPE_32:
                            _lastAnsInt = UInt64Cast<SInt08, SInt32>(_lastAnsInt);
                            break;
                        case BITTYPE_64:
                            _lastAnsInt = UInt64Cast<SInt08, SInt64>(_lastAnsInt);
                            break;
                    }
                    break;
                case BITTYPE_16:
                    switch (param) {
                        case BITTYPE_08:
                            _lastAnsInt = UInt64Cast<SInt16, SInt08>(_lastAnsInt);
                            break;
                        case BITTYPE_32:
                            _lastAnsInt = UInt64Cast<SInt16, SInt32>(_lastAnsInt);
                            break;
                        case BITTYPE_64:
                            _lastAnsInt = UInt64Cast<SInt16, SInt64>(_lastAnsInt);
                            break;
                    }
                    break;
                case BITTYPE_32:
                    switch (param) {
                        case BITTYPE_08:
                            _lastAnsInt = UInt64Cast<SInt32, SInt08>(_lastAnsInt);
                            break;
                        case BITTYPE_16:
                            _lastAnsInt = UInt64Cast<SInt32, SInt16>(_lastAnsInt);
                            break;
                        case BITTYPE_64:
                            _lastAnsInt = UInt64Cast<SInt32, SInt64>(_lastAnsInt);
                            break;
                    }
                    break;
                case BITTYPE_64:
                    switch (param) {
                        case BITTYPE_08:
                            _lastAnsInt = UInt64Cast<SInt64, SInt08>(_lastAnsInt);
                            break;
                        case BITTYPE_16:
                            _lastAnsInt = UInt64Cast<SInt64, SInt16>(_lastAnsInt);
                            break;
                        case BITTYPE_32:
                            _lastAnsInt = UInt64Cast<SInt64, SInt32>(_lastAnsInt);
                            break;
                    }
                    break;
            }
        }
        _monitor->SetAnswer(UInt64ToAnswer(_lastAnsInt, _sign, param, _number));
    }
    _bit = param;
    _monitor->SetBitType(_bit);
    return;
}

Void Calculator::SetAngleType(AngleTypeEnum param)
{
    SFXAnsiString str(_monitor->GetAnswer());
    Float64 val;

    if(!str.IsEmptyCString() && _angle != param) {
        // ɕ\\̓ϊ
        switch (_angle) {
            case ANGLETYPE_DEG:
                val = SuperMath::FromDegToRad(_lastAnsReal);
                break;
            case ANGLETYPE_GRA:
                val = SuperMath::FromGradToRad(_lastAnsReal);
                break;
            default:
                val = _lastAnsReal;
                break;
        }
        switch (param) {
            case ANGLETYPE_DEG:
                val = SuperMath::FromRadToDeg(val);
                break;
            case ANGLETYPE_GRA:
                val = SuperMath::FromRadToGrad(val);
                break;
        }
        DisplayReal(val);
        _lastAnsInt = static_cast<UInt64>(val);
        _lastAnsReal = val;
    }
    _angle = param;
    _monitor->SetAngleType(_angle);
    return;
}

Void Calculator::CheckDigit(UInt08Ptr pbuf, SInt16Ptr porder, SInt16Ptr plast)
{
    SInt16 i;

    if (pbuf[0] >= 10) {
        for (i = FLOATTOSTR_BUFSIZE - 1; i > 1; --i) {
            pbuf[i] = pbuf[i - 1];
        }
        pbuf[1] = pbuf[0] % 10;
        pbuf[0] /= 10;
        ++(*porder);
    }
    for (i = 0; i < FLOATTOSTR_BUFSIZE; ++i) {
        if (pbuf[i]) {
            *plast = i;
        }
    }
}

Void Calculator::Round(UInt08Ptr pbuf, SInt16Ptr porder, SInt16Ptr plast, UInt16 digit /* ľܓʒu */)
{
    SInt16 i;
    UInt08 d;

    pbuf[digit] += 5;
    for (i = digit; i > 0; ) {
        if (pbuf[i] < 10) {
            break;
        }
        else {
            d = pbuf[i] / 10;
            pbuf[i] -= (d * 10);
            pbuf[--i] += d;
        }
    }
    for (i = digit; i < FLOATTOSTR_BUFSIZE; ++i) {
        pbuf[i] = 0;
    }
    CheckDigit(pbuf, porder, plast);
}

Void Calculator::DisplayRealInner(UInt08Ptr pbuf, SInt16Ptr porder, SInt16Ptr plast, Float64 val)
{
    SInt16 i;
    UInt08 d(0);
    Float64 t;

    SFXHelper::memset(pbuf, 0, sizeof(UInt08) * FLOATTOSTR_BUFSIZE);
    for (i = 0; i < FLOATTOSTR_BUFSIZE; ++i) {
        t = SuperMath::Floor(val);
        pbuf[i] = static_cast<UInt08>(t);
        val = (val - t) * 10.0;
    }
    if (val >= 5.0) {
        ++pbuf[FLOATTOSTR_BUFSIZE - 1];
    }
    for (i = FLOATTOSTR_BUFSIZE - 1; i > 0; ) {
        if (pbuf[i] < 10) {
            break;
        }
        else {
            d = pbuf[i] / 10;
            pbuf[i] -= (d * 10);
            pbuf[--i] += d;
        }
    }
    CheckDigit(pbuf, porder, plast);
}


Void Calculator::DisplayReal(Float64 val)
{
    UInt08 buf[FLOATTOSTR_BUFSIZE];
    SInt16 order, i, last(0), max(0);
    SFXAnsiString str, strExp;
    SFXSize size(_monitor->GetSize());
    UInt16 displayWidth(size.GetWidth());
    Float64 tmpVal;
    Bool flag(false);

    if (val < 0.0) {
        str = "-";
        val = -val;
        --displayWidth;
    }
    if (_unit != UNIT_NONE) {
        val *= SuperMath::Pow(10.0, - static_cast<Float64>(3 * (_unit - UNIT_NONE)));   // v`FbN
        --displayWidth;
    }
    if (val == 0.0) {
        order = 0;
    }
    else {
        order = static_cast<SInt16>(SuperMath::Floor(SuperMath::Log10(val)));
    }
    tmpVal = val * SuperMath::Pow(10.0, -static_cast<Float64>(order));
    DisplayRealInner(buf, &order, &last, tmpVal);
    Round(buf, &order, &last, static_cast<UInt16>(displayWidth));

    if (order >= 0 && order < displayWidth) {
        if (order >= last) {
            for (i = 0; i <= last; ++i) {
                str += (buf[i] + '0');
            }
            max = order - last;
            for (i = 0; i < max; ++i) {
                str += '0';
            }
            flag = true;
        }
        else if (order >= displayWidth - 2) {
            // ͂ݏoľܓĂ\\ł邩ǂ`FbNKvȂ
            Round(buf, &order, &last, (order == displayWidth - 1) ? displayWidth : (displayWidth - 1));
            if (order < displayWidth) {
                for (i = 0; i <= order; ++i) {
                    str += (buf[i] + '0');
                }
                flag = true;
            }
            else {
                // Ŏw\\Ȃ΂ȂȂ̂ŁAɖ߂Ă
                DisplayRealInner(buf, &order, &last, tmpVal);
                Round(buf, &order, &last, static_cast<UInt16>(displayWidth));
            }
        }
        else {
            // rɏ_
            Round(buf, &order, &last, displayWidth - 1);
            for (i = 0; i <= order; ++i) {
                str += (buf[i] + '0');
            }
            if (i <= last) {
                str += '.';
            }
            for ( ; i <= last; ++i) {
                str += (buf[i] + '0');
            }
            flag = true;
        }
    }
    else if (order < 0) {
        if ((last - order + 2) <= displayWidth) {
            // 1 ̒lŁÂ܂ܕ\\\Ȃ
            str += "0.";
            for (i = 1; i < -order; ++i) {
                str += '0';
            }
            for (i = 0; i <= last; ++i) {
                str += (buf[i] + '0');
            }
            flag = true;
        }
        else if (order >= EXPRESSION_THRESHOLD) {
            // ͂ݏoꍇA臒lȏȂ炻̂܂ܕ\\
            Round(buf, &order, &last, static_cast<UInt16>(displayWidth + order - 1));
            str += "0.";
            for (i = 1; i < -order; ++i) {
                str += '0';
            }
            for (i = 0; i <= last; ++i) {
                str += (buf[i] + '0');
            }
            flag = true;
        }
    }
    if (!flag) {
        // w\\Ȃ΂ȂȂ
        strExp = SFXAnsiString::Format("E%+hd", order);
        Round(buf, &order, &last, static_cast<UInt16>(displayWidth - strExp.GetLengthCString() - 1));
        strExp = SFXAnsiString::Format("E%+hd", order);
        str += (buf[0] + '0');
        if (last >= 1) {
            str += '.';
        }
        for (i = 1; i <= last; ++i) {
            str += (buf[i] + '0');
        }
        str += strExp;
    }

    switch (_unit) {
        case UNIT_FEMTO:
            str += "f";
            break;
        case UNIT_PICO:
            str += "p";
            break;
        case UNIT_NANO:
            str += "n";
            break;
        case UNIT_MICRO:
            str += "u";
            break;
        case UNIT_MILLI:
            str += "m";
            break;
        case UNIT_KILO:
            str += "K";
            break;
        case UNIT_MEGA:
            str += "M";
            break;
        case UNIT_GIGA:
            str += "G";
            break;
        case UNIT_TERA:
            str += "T";
            break;
    }
    _monitor->SetAnswer(str);
}

SFCError Calculator::Initialize(Void)
{
    // Ō̌vZʂ config t@Cǂݍ
    SFXConfig config;
    SFCError error(SFERR_NO_ERROR);
    if ((error = config.Load(SFXPath(CONFIG_FILENAME))) == SFERR_NO_ERROR) {
        _lastAnsInt = config.ReadUInt64(CONFIGTAG_ANSINT, 0);
        _lastAnsReal = config.ReadFloat64(CONFIGTAG_ANSREAL, 0.0);
        _ansOct = static_cast<AnsOctEnum>(config.ReadUInt32(CONFIGTAG_ANSOCT, ANSOCT_REAL));
        _number = static_cast<NumberTypeEnum>(config.ReadUInt32(CONFIGTAG_TYPENUMBER, NUMBERTYPE_DEC));
        _sign = static_cast<SignTypeEnum>(config.ReadUInt32(CONFIGTAG_TYPESIGN, SIGNTYPE_S));
        _bit = static_cast<BitTypeEnum>(config.ReadUInt32(CONFIGTAG_TYPEBIT, BITTYPE_64));
        _angle = static_cast<AngleTypeEnum>(config.ReadUInt32(CONFIGTAG_TYPEANGLE, ANGLETYPE_RAD));
    } else {
        _lastAnsInt = 0;
        _lastAnsReal = 0.0;
        _ansOct = ANSOCT_REAL;
        _number = NUMBERTYPE_DEC;
        _sign = SIGNTYPE_S;
        _bit = BITTYPE_64;
        _angle = ANGLETYPE_RAD;
    }

    // config t@C̓e̐
    if (_ansOct >= ANSOCT_LIMIT) {
        error = SFERR_FAILED;
        _ansOct = ANSOCT_REAL;
    }
    if (_number >= NUMBERTYPE_LIMIT) {
        error = SFERR_FAILED;
        _number = NUMBERTYPE_DEC;
    }
    if (_sign >= SIGNTYPE_LIMIT) {
        error = SFERR_FAILED;
        _sign = SIGNTYPE_S;
    }
    if (_bit >= BITTYPE_LIMIT) {
        error = SFERR_FAILED;
        _bit = BITTYPE_64;
    }
    if (_angle >= ANGLETYPE_LIMIT) {
        error = SFERR_FAILED;
        _angle = ANGLETYPE_RAD;
    }

    _lastNumber = _number;
    _lastSign = _sign;
    _lastBit = _bit;
    _lastAngle = _angle;
    _unit = UNIT_NONE;

    _monitor->SetNumberType(_number);
    _monitor->SetSignType(_sign);
    _monitor->SetBitType(_bit);
    _monitor->SetAngleType(_angle);

    return error;
}

SFCError Calculator::Terminate(Void)
{
    SFCError error;

    DBGPRINTF(">> Terminate");

    // Ō̌vZʂ config t@Cɏ
    SFXConfig config;
    config.WriteUInt64(CONFIGTAG_ANSINT, _lastAnsInt);
    config.WriteFloat64(CONFIGTAG_ANSREAL, _lastAnsReal);
    config.WriteUInt32(CONFIGTAG_ANSOCT, static_cast<UInt32>(_ansOct));
    config.WriteUInt32(CONFIGTAG_TYPENUMBER, static_cast<UInt32>(_number));
    config.WriteUInt32(CONFIGTAG_TYPESIGN, static_cast<UInt32>(_sign));
    config.WriteUInt32(CONFIGTAG_TYPEBIT, static_cast<UInt32>(_bit));
    config.WriteUInt32(CONFIGTAG_TYPEANGLE, static_cast<UInt32>(_angle));

    DBGPRINTF("before save");

    SInt32 i, j, k;
    for (i = 0; i < 1000000; ++i) {
        for (j = 0; j < 1000000; ++j) {
            k = i * j;
        }
    }

    error = config.Save(SFXPath(CONFIG_FILENAME));

    for (i = 0; i < 1000000; ++i) {
        for (j = 0; j < 1000000; ++j) {
            k = i * j;
        }
    }

    DBGPRINTF("<< Terminate");
    return error;
}

Void Calculator::New(Void)
{
    _monitor->SetFormula("");
    _monitor->SetCursor(0);
    _monitor->SetAnswer("");
    _sequence.Clear();
    return;
}

Void Calculator::Dispose(Void)
{
    _monitor->SetFormula("");
    _monitor->SetCursor(0);
    _monitor->SetAnswer("");
    _sequence.Clear();
    return;
}

Void Calculator::Continue(Void)
{
    Cursor cursor(_sequence.GetCursor(_sequence.GetSize()));
    _number = _lastNumber;
    _sign = _lastSign;
    _bit = _lastBit;
    _angle = _lastAngle;

    _monitor->SetCursor(cursor.GetPosition(), cursor.GetLength());
    _monitor->SetAnswer("");
    _monitor->SetNumberType(_number);
    _monitor->SetSignType(_sign);
    _monitor->SetBitType(_bit);
    _monitor->SetAngleType(_angle);
    return;
}

//////////////////////////////////////////////////////
// f[^̒l
// f[^̕
// f[^̃rbg
// ϊΏېi
SFXAnsiString Calculator::UInt64ToAnswer(UInt64 value, Calculator::SignTypeEnum sign, Calculator::BitTypeEnum bit, Calculator::NumberTypeEnum number)
{
    static SInt16Const ltable[Calculator::NUMBERTYPE_LIMIT][Calculator::BITTYPE_LIMIT] = {
        { 8, 16, 32, 64},
        { 4,  8, 16, 32},
        { 4,  6, 11, 21},
        { 2,  4,  8, 16}
    };
    static SInt16Const stable[Calculator::NUMBERTYPE_LIMIT] = {
        2, 8, 10, 16
    };
    static ACharConst digit[] = "0123456789ABCDEF";
    SInt16 length(ltable[number][bit]);
    SInt16 shift(stable[number]);
    SInt16 i;
    Bool minus;
    Bool allZero(true);
    SFXAnsiString result;

    if (result.SetLength(length) == SFERR_NO_ERROR) {
        switch (number) {
            case Calculator::NUMBERTYPE_BIN:
            case Calculator::NUMBERTYPE_OCT:
            case Calculator::NUMBERTYPE_HEX:
                for (i = length - 1; i >= 0; --i, value /= shift) {
                    result[i] = digit[value % shift];
                }
                break;
            case Calculator::NUMBERTYPE_DEC:
                minus = false;
                if (sign == Calculator::SIGNTYPE_S) {
                    if (value & SINT64_MINIMUM) {
                        value = -static_cast<SInt64>(value);
                        minus = true;
                    }
                }
                for (i = length - 1; i > 0; --i, value /= shift) {
                    result[i] = digit[value % shift];
                }
                for (i = 1; i < length; ++i) {
                    if (result[i] != '0') {
                        allZero = false;
                        if (minus) {
                            result[--i] = '-';
                        }
                        result = result.Remove(0, i);
                        break;
                    }
                }
                if (allZero) {
                    result = "0";
                }
                break;
        }
    }
    return result;
}
//////////////////////////////////////////////////////


SFCError Calculator::Execute(Void)
{
    SFCError result(SFERR_NO_ERROR);

    _lastNumber = _number;
    _lastSign = _sign;
    _lastBit = _bit;
    _lastAngle = _angle;

    if (_number == NUMBERTYPE_DEC) {
        result = CalculateReal();
    }
    else {
        switch (_bit) {
            case BITTYPE_08:
                if (_sign == SIGNTYPE_U) {
                    result = CalculateUInt08();
                }
                else {
                    result = CalculateSInt08();
                }
                break;
            case BITTYPE_16:
                if (_sign == SIGNTYPE_U) {
                    result = CalculateUInt16();
                }
                else {
                    result = CalculateSInt16();
                }
                break;
            case BITTYPE_32:
                if (_sign == SIGNTYPE_U) {
                    result = CalculateUInt32();
                }
                else {
                    result = CalculateSInt32();
                }
                break;
            case BITTYPE_64:
                if (_sign == SIGNTYPE_U) {
                    result = CalculateUInt64();
                }
                else {
                    result = CalculateSInt64();
                }
                break;
        }
    }
    return result;
}

Void Calculator::View_left(Void)
{
    _monitor->SetBlock(_monitor->GetBlock() + 1);
    return;
}

Void Calculator::View_right(Void)
{
    _monitor->SetBlock(_monitor->GetBlock() - 1);
    return;
}

// Pʐ؂ւ
Void Calculator::View_plus(Void)
{
    SFXAnsiString str(_monitor->GetAnswer());

    if (!str.IsEmptyCString()) {
        if (_unit < UNIT_TERA) {
            ++_unit;
            DisplayReal(_lastAnsReal);
        }
    }
    return;
}

// Pʐ؂ւ
Void Calculator::View_minus(Void)
{
    SFXAnsiString str(_monitor->GetAnswer());

    if (!str.IsEmptyCString()) {
        if (_unit > UNIT_FEMTO) {
            --_unit;
            DisplayReal(_lastAnsReal);
        }
    }
    return;
}

Void Calculator::Edit_clear(Void)
{
    SInt32Const index(_sequence.GetIndex(_monitor->GetCursor()));
    SInt32Const size(_sequence.GetSize());
    if (index < size) {
        _sequence.Remove(index);
    }
    else {
        _sequence.Remove(size - 1);
    }
    SFXAnsiString str(_sequence.GetString());
    _monitor->SetFormula(str);
    Cursor cursor(_sequence.GetCorrectCursor(_monitor->GetCursor()));
    _monitor->SetCursor(cursor.GetPosition(), cursor.GetLength());
    return;
}

Void Calculator::Edit_up(Void)
{
    Cursor cursor(_sequence.GetCorrectCursor(_monitor->GetCursor() - _monitor->GetSize().GetWidth()));
    _monitor->SetCursor(cursor.GetPosition(), cursor.GetLength());
    return;
}

Void Calculator::Edit_down(Void)
{
    Cursor cursor(_sequence.GetCorrectCursor(_monitor->GetCursor() + _monitor->GetSize().GetWidth()));
    _monitor->SetCursor(cursor.GetPosition(), cursor.GetLength());
    return;
}

Void Calculator::Edit_left(Void)
{
    Cursor cursor(_sequence.GetPreviousCursor(_monitor->GetCursor()));
    _monitor->SetCursor(cursor.GetPosition(), cursor.GetLength());
    return;
}

Void Calculator::Edit_right(Void)
{
    Cursor cursor(_sequence.GetNextCursor(_monitor->GetCursor()));
    _monitor->SetCursor(cursor.GetPosition(), cursor.GetLength());
    return;
}

Void Calculator::SetKey(KeyType::KeyCode code)
{
    Cursor cursor;
    SInt32 index;
    SFCError error;

    index = _sequence.GetIndex(_monitor->GetCursor());
    if (((code & KeyType::KEYCLASS_FUNCTION) && code != KeyType::KEYCODE_FUNCTION_SEPARATOR) || code == KeyType::KEYCODE_PARENTHESIS_LEFT) {
        error = _sequence.Insert(index, KeyType(KeyType::KEYCODE_PARENTHESIS_RIGHT));
        if (error == SFERR_NO_ERROR) {
            error = _sequence.Insert(index, KeyType(code));
        }
    }
    else {
        error = _sequence.Insert(index, KeyType(code));
    }
    if (error == SFERR_NO_ERROR) {
        _monitor->SetFormula(_sequence.GetString());
        cursor = _sequence.GetCursor(index + 1);
        _monitor->SetCursor(cursor.GetPosition(), cursor.GetLength());
    }
}

SFCError Calculator::CalculateSInt08(Void)
{
    SFCError result;
    KeySequence tmpKeySeq;
    Expression<SInt08> expression;
    Sangi<SInt08> sangi;

    if ((result = tmpKeySeq.Set(_sequence)) == SFERR_NO_ERROR) {
        result = tmpKeySeq.Normalize();
    }
    if (result == SFERR_NO_ERROR) {
        switch (_number) {
            case NUMBERTYPE_BIN:
                expression.SetRadixBit(1);
                break;
            case NUMBERTYPE_OCT:
                expression.SetRadixBit(3);
                break;
            case NUMBERTYPE_HEX:
                expression.SetRadixBit(4);
                break;
        }
        expression.SetAns(static_cast<SInt08>(_lastAnsInt));
        expression.Set(tmpKeySeq);
        result = expression.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        sangi.Solve(expression);
        result = sangi.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        _monitor->SetAnswer(UInt64ToAnswer(static_cast<UInt64>(sangi.GetResult()), SIGNTYPE_S, BITTYPE_08, _number));
        _lastAnsInt = static_cast<UInt64>(sangi.GetResult());
        _lastAnsReal = static_cast<Float64>(sangi.GetResult());
        _ansOct = ANSOCT_REAL;
    }
    return result;
}

SFCError Calculator::CalculateUInt08(Void)
{
    SFCError result;
    KeySequence tmpKeySeq;
    Expression<UInt08> expression;
    Sangi<UInt08> sangi;

    if ((result = tmpKeySeq.Set(_sequence)) == SFERR_NO_ERROR) {
        result = tmpKeySeq.Normalize();
    }
    if (result == SFERR_NO_ERROR) {
        switch (_number) {
            case NUMBERTYPE_BIN:
                expression.SetRadixBit(1);
                break;
            case NUMBERTYPE_OCT:
                expression.SetRadixBit(3);
                break;
            case NUMBERTYPE_HEX:
                expression.SetRadixBit(4);
                break;
        }
        expression.SetAns(static_cast<UInt08>(_lastAnsInt));
        expression.Set(tmpKeySeq);
        result = expression.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        sangi.Solve(expression);
        result = sangi.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        _monitor->SetAnswer(UInt64ToAnswer(static_cast<UInt64>(sangi.GetResult()), SIGNTYPE_U, BITTYPE_08, _number));
        _lastAnsInt = static_cast<UInt64>(sangi.GetResult());
        _lastAnsReal = static_cast<Float64>(sangi.GetResult());
        _ansOct = ANSOCT_REAL;
    }
    return result;
}

SFCError Calculator::CalculateSInt16(Void)
{
    SFCError result;
    KeySequence tmpKeySeq;
    Expression<SInt16> expression;
    Sangi<SInt16> sangi;

    if ((result = tmpKeySeq.Set(_sequence)) == SFERR_NO_ERROR) {
        result = tmpKeySeq.Normalize();
    }
    if (result == SFERR_NO_ERROR) {
        switch (_number) {
            case NUMBERTYPE_BIN:
                expression.SetRadixBit(1);
                break;
            case NUMBERTYPE_OCT:
                expression.SetRadixBit(3);
                break;
            case NUMBERTYPE_HEX:
                expression.SetRadixBit(4);
                break;
        }
        expression.SetAns(static_cast<SInt16>(_lastAnsInt));
        expression.Set(tmpKeySeq);
        result = expression.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        sangi.Solve(expression);
        result = sangi.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        _monitor->SetAnswer(UInt64ToAnswer(static_cast<UInt64>(sangi.GetResult()), SIGNTYPE_S, BITTYPE_16, _number));
        _lastAnsInt = static_cast<UInt64>(sangi.GetResult());
        _lastAnsReal = static_cast<Float64>(sangi.GetResult());
        _ansOct = ANSOCT_REAL;
    }
    return result;
}

SFCError Calculator::CalculateUInt16(Void)
{
    SFCError result;
    KeySequence tmpKeySeq;
    Expression<UInt16> expression;
    Sangi<UInt16> sangi;

    if ((result = tmpKeySeq.Set(_sequence)) == SFERR_NO_ERROR) {
        result = tmpKeySeq.Normalize();
    }
    if (result == SFERR_NO_ERROR) {
        switch (_number) {
            case NUMBERTYPE_BIN:
                expression.SetRadixBit(1);
                break;
            case NUMBERTYPE_OCT:
                expression.SetRadixBit(3);
                break;
            case NUMBERTYPE_HEX:
                expression.SetRadixBit(4);
                break;
        }
        expression.SetAns(static_cast<UInt16>(_lastAnsInt));
        expression.Set(tmpKeySeq);
        result = expression.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        sangi.Solve(expression);
        result = sangi.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        _monitor->SetAnswer(UInt64ToAnswer(static_cast<UInt64>(sangi.GetResult()), SIGNTYPE_U, BITTYPE_16, _number));
        _lastAnsInt = static_cast<UInt64>(sangi.GetResult());
        _lastAnsReal = static_cast<Float64>(sangi.GetResult());
        _ansOct = ANSOCT_REAL;
    }
    return result;
}

SFCError Calculator::CalculateSInt32(Void)
{
    SFCError result;
    KeySequence tmpKeySeq;
    Expression<SInt32> expression;
    Sangi<SInt32> sangi;

    if ((result = tmpKeySeq.Set(_sequence)) == SFERR_NO_ERROR) {
        result = tmpKeySeq.Normalize();
    }
    if (result == SFERR_NO_ERROR) {
        switch (_number) {
            case NUMBERTYPE_BIN:
                expression.SetRadixBit(1);
                break;
            case NUMBERTYPE_OCT:
                expression.SetRadixBit(3);
                break;
            case NUMBERTYPE_HEX:
                expression.SetRadixBit(4);
                break;
        }
        expression.SetAns(static_cast<SInt32>(_lastAnsInt));
        expression.Set(tmpKeySeq);
        result = expression.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        sangi.Solve(expression);
        result = sangi.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        _monitor->SetAnswer(UInt64ToAnswer(static_cast<UInt64>(sangi.GetResult()), SIGNTYPE_S, BITTYPE_32, _number));
        _lastAnsInt = static_cast<UInt64>(sangi.GetResult());
        _lastAnsReal = static_cast<Float64>(sangi.GetResult());
        _ansOct = ANSOCT_REAL;
    }
    return result;
}

SFCError Calculator::CalculateUInt32(Void)
{
    SFCError result;
    KeySequence tmpKeySeq;
    Expression<UInt32> expression;
    Sangi<UInt32> sangi;

    if ((result = tmpKeySeq.Set(_sequence)) == SFERR_NO_ERROR) {
        result = tmpKeySeq.Normalize();
    }
    if (result == SFERR_NO_ERROR) {
        switch (_number) {
            case NUMBERTYPE_BIN:
                expression.SetRadixBit(1);
                break;
            case NUMBERTYPE_OCT:
                expression.SetRadixBit(3);
                break;
            case NUMBERTYPE_HEX:
                expression.SetRadixBit(4);
                break;
        }
        expression.SetAns(static_cast<UInt32>(_lastAnsInt));
        expression.Set(tmpKeySeq);
        result = expression.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        sangi.Solve(expression);
        result = sangi.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        _monitor->SetAnswer(UInt64ToAnswer(static_cast<UInt64>(sangi.GetResult()), SIGNTYPE_U, BITTYPE_32, _number));
        _lastAnsInt = static_cast<UInt64>(sangi.GetResult());
        _lastAnsReal = static_cast<Float64>(sangi.GetResult());
        _ansOct = ANSOCT_REAL;
    }
    return result;
}

SFCError Calculator::CalculateSInt64(Void)
{
    SFCError result;
    KeySequence tmpKeySeq;
    Expression<SInt64> expression;
    Sangi<SInt64> sangi;

    if ((result = tmpKeySeq.Set(_sequence)) == SFERR_NO_ERROR) {
        result = tmpKeySeq.Normalize();
    }
    if (result == SFERR_NO_ERROR) {
        switch (_number) {
            case NUMBERTYPE_BIN:
                expression.SetRadixBit(1);
                break;
            case NUMBERTYPE_OCT:
                expression.SetRadixBit(3);
                break;
            case NUMBERTYPE_HEX:
                expression.SetRadixBit(4);
                break;
        }
        expression.SetAns(static_cast<SInt64>(_lastAnsInt));
        expression.Set(tmpKeySeq);
        result = expression.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        sangi.Solve(expression);
        result = sangi.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        _monitor->SetAnswer(UInt64ToAnswer(static_cast<UInt64>(sangi.GetResult()), SIGNTYPE_S, BITTYPE_64, _number));
        _lastAnsInt = static_cast<UInt64>(sangi.GetResult());
        _lastAnsReal = static_cast<Float64>(sangi.GetResult());
        _ansOct = ANSOCT_REAL;
    }
    return result;
}

SFCError Calculator::CalculateUInt64(Void)
{
    SFCError result;
    KeySequence tmpKeySeq;
    Expression<UInt64> expression;
    Sangi<UInt64> sangi;

    if ((result = tmpKeySeq.Set(_sequence)) == SFERR_NO_ERROR) {
        result = tmpKeySeq.Normalize();
    }
    if (result == SFERR_NO_ERROR) {
        switch (_number) {
            case NUMBERTYPE_BIN:
                expression.SetRadixBit(1);
                break;
            case NUMBERTYPE_OCT:
                expression.SetRadixBit(3);
                break;
            case NUMBERTYPE_HEX:
                expression.SetRadixBit(4);
                break;
        }
        expression.SetAns(_lastAnsInt);
        expression.Set(tmpKeySeq);
        result = expression.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        sangi.Solve(expression);
        result = sangi.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        _monitor->SetAnswer(UInt64ToAnswer(sangi.GetResult(), SIGNTYPE_U, BITTYPE_64, _number));
        _lastAnsInt = sangi.GetResult();
        _lastAnsReal = UInt64ToFloat64(sangi.GetResult());
        _ansOct = ANSOCT_REAL;
    }
    return result;
}

SFCError Calculator::CalculateReal(Void)
{
    SFCError result;
    KeySequence tmpKeySeq;
    Expression<Float64> expression;
    Sangi<Float64> sangi;
    Float64 val;

    if ((result = tmpKeySeq.Set(_sequence)) == SFERR_NO_ERROR) {
        result = tmpKeySeq.Normalize();
    }
    if (result == SFERR_NO_ERROR) {
        if (_ansOct == ANSOCT_OCT) {
            expression.SetAns(UInt64ToFloat64(_lastAnsInt));
        }
        else {
            expression.SetAns(_lastAnsReal);
        }
        expression.Set(tmpKeySeq);
        result = expression.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        switch (GetAngleType()) {
            case ANGLETYPE_DEG:
                sangi.SetAngleMode(Sangi<Float64>::ANGLEMODE_DEG);
                break;
            case ANGLETYPE_GRA:
                sangi.SetAngleMode(Sangi<Float64>::ANGLEMODE_GRD);
                break;
            default:
                sangi.SetAngleMode(Sangi<Float64>::ANGLEMODE_RAD);
                break;
        }
        sangi.Solve(expression);
        result = sangi.static_catch();
    }
    if (result == SFERR_NO_ERROR) {
        _unit = UNIT_NONE;
        if (expression.HasUnit()) {
            val = SuperMath::Fabs(sangi.GetResult());
            while (val < 1.0 && _unit > UNIT_FEMTO) {
                --_unit;
                val *= 1000.0;
            }
            while (val >= 1000.0 && _unit < UNIT_TERA) {
                ++_unit;
                val /= 1000.0;
            }
        }
        DisplayReal(sangi.GetResult());
        _lastAnsInt = static_cast<UInt64>(sangi.GetResult());
        _lastAnsReal = sangi.GetResult();
        _ansOct = ANSOCT_REAL;
    }
    return result;
}
