#ifndef __SOPHIACRADLE_CURSOR_HPP
#define __SOPHIACRADLE_CURSOR_HPP

#include <SophiaFramework.hpp>

SFMTYPEDEFCLASS(Cursor)
class Cursor {
private:
    SInt16 _position;
    SInt16 _length;

public:
    explicit Cursor(Void);
    Cursor(CursorConstRef cursor);
    explicit Cursor(SInt16 position, SInt16 length = 1);
    virtual ~Cursor(Void);
    CursorConstRef operator=(CursorConstRef cursor);
    Void Set(CursorConstRef cursor);
    Void Set(SInt16 position, SInt16 length = 1);
    Void SetPosition(SInt16 position);
    Void SetLength(SInt16 length);
    SInt16 GetPosition(Void) const;
    SInt16 GetLength(Void) const;
};

inline Cursor::Cursor(Void) : _position(0), _length(1)
{
}

inline Cursor::Cursor(CursorConstRef cursor) : _position(cursor._position), _length(cursor._length)
{
}

inline Cursor::Cursor(SInt16 position, SInt16 length) : _position(position), _length(length)
{
}

inline Cursor::~Cursor(Void)
{
}

inline CursorConstRef Cursor::operator=(CursorConstRef cursor)
{
    Set(cursor);
    return *this;
}

inline Void Cursor::Set(CursorConstRef cursor)
{
    _position = cursor._position;
    _length = cursor._length;
}

inline Void Cursor::Set(SInt16 position, SInt16 length)
{
    _position = position;
    _length = length;
}

inline Void Cursor::SetPosition(SInt16 position)
{
    _position = position;
}

inline Void Cursor::SetLength(SInt16 length)
{
    _length = length;
}

inline SInt16 Cursor::GetPosition(Void) const
{
    return _position;
}

inline SInt16 Cursor::GetLength(Void) const
{
    return _length;
}

#endif
