//
//      FSKeyboard.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.0.
//

#include "FSKeyboard.hpp"
#include "FNKeyboard.hpp"
#include "TSKeyboard.hpp"

FSKeyboard::FSKeyboard(SFRApplicationPtr director, SFXRectangleConstRef rect, MonitorPtr monitor, CalculatorPtr calculator) static_throws : Keyboard(director, rect, ATTRIBUTE_FSKEYBOARD, monitor, calculator)
{
    if (static_try()) {
        Refresh();
    }
    return;
}

FSKeyboardPtr FSKeyboard::GetInstance(Void)
{
    return static_cast<FSKeyboardPtr>(Keyboard::GetInstance(ATTRIBUTE_FSKEYBOARD));
}

Void FSKeyboard::HandlerClear(Void)
{
    Return();
    return;
}

Void FSKeyboard::Handler1(Void)
{
    GetCalculator()->Function_abs();
    Return();
    return;
}

Void FSKeyboard::Handler2(Void)
{
    GetCalculator()->Function_frac();
    Return();
    return;
}

Void FSKeyboard::Handler3(Void)
{
    GetCalculator()->Function_cbrt();
    Return();
    return;
}

Void FSKeyboard::Handler4(Void)
{
    GetCalculator()->Function_pow();
    Return();
    return;
}

Void FSKeyboard::Handler6(Void)
{
    GetCalculator()->Function_exp();
    Return();
    return;
}

Void FSKeyboard::Handler7(Void)
{
    GetCalculator()->Function_gamma();
    Return();
    return;
}

Void FSKeyboard::Handler8(Void)
{
    GetCalculator()->Function_nPr();
    Return();
    return;
}

Void FSKeyboard::Handler9(Void)
{
    GetCalculator()->Function_yn();
    Return();
    return;
}

Void FSKeyboard::HandlerStar(Void)
{
    Return();
    return;
}

Void FSKeyboard::Handler0(Void)
{
    KeyboardPtr keyboard;

    if ((keyboard = TSKeyboard::GetInstance()) != null) {
        keyboard->Activate(this);
    }
    return;
}

Void FSKeyboard::HandlerPound(Void)
{
    KeyboardPtr keyboard;

    if ((keyboard = FNKeyboard::GetInstance()) != null) {
        keyboard->Activate(this);
    }
    return;
}

Void FSKeyboard::Refresh(Void)
{
    static MapRecConst map = {{
        {          MAP_UNDEFINED,                MAP_RTN,                MAP_OFF},
        {{  "abs", COLOR_NORMAL}, {"frac", COLOR_NORMAL}, {"cbrt", COLOR_NORMAL}},
        {{  "pow", COLOR_NORMAL},          MAP_UNDEFINED, { "exp", COLOR_NORMAL}},
        {{"gamma", COLOR_NORMAL}, { "nPr", COLOR_NORMAL}, {  "yn", COLOR_NORMAL}},
        {                MAP_VAL,                MAP_TRI,                MAP_NML}
    }};

    Keyboard::Refresh(map);
    return;
}

Void FSKeyboard::Activate(KeyboardPtr inactivate)
{
    Keyboard::Activate(inactivate, Monitor::MODE_FUNCTION | Monitor::MODE_SHIFT);
    return;
}
