#ifndef __SOPHIACRADLE_KEYSEQUENCE_HPP
#define __SOPHIACRADLE_KEYSEQUENCE_HPP

#include <SophiaFramework.hpp>
#include "Array.hpp"
#include "Cursor.hpp"

SFMTYPEDEFCLASS(KeyType)
class KeyType {
// L[ Ɋւ舵NX
public:
    enum KeyCode {
        // ǉ͊eނ̍Ōɒǉ邱 (厖)
        KEYCODE_NONE = 0x0000,              // `
        KEYCODE_NUMBER_0 = 0x0100,          // 0 L[
        KEYCODE_NUMBER_1 = 0x0101,          // 1 L[
        KEYCODE_NUMBER_2 = 0x0102,          // 2 L[
        KEYCODE_NUMBER_3 = 0x0103,          // 3 L[
        KEYCODE_NUMBER_4 = 0x0104,          // 4 L[
        KEYCODE_NUMBER_5 = 0x0105,          // 5 L[
        KEYCODE_NUMBER_6 = 0x0106,          // 6 L[
        KEYCODE_NUMBER_7 = 0x0107,          // 7 L[
        KEYCODE_NUMBER_8 = 0x0108,          // 8 L[
        KEYCODE_NUMBER_9 = 0x0109,          // 9 L[
        KEYCODE_NUMBER_A = 0x010A,          // A L[
        KEYCODE_NUMBER_B = 0x010B,          // B L[
        KEYCODE_NUMBER_C = 0x010C,          // C L[
        KEYCODE_NUMBER_D = 0x010D,          // D L[
        KEYCODE_NUMBER_E = 0x010E,          // E L[
        KEYCODE_NUMBER_F = 0x010F,          // F L[
        KEYCODE_CONSTANT_PI = 0x0200,       // PI L[
        KEYCODE_CONSTANT_E = 0x0201,        // lCsAL[
        KEYCODE_CONSTANT_RAN = 0x0202,      //  (萔ł͂ȂÅ֌Włɕ)
        KEYCODE_UNIT_TERA = 0x0400,         // e L[
        KEYCODE_UNIT_GIGA = 0x0401,         // MK L[
        KEYCODE_UNIT_MEGA = 0x0402,         // K L[
        KEYCODE_UNIT_KILO = 0x0403,         // L L[
        KEYCODE_UNIT_MILLI = 0x0404,        // ~ L[
        KEYCODE_UNIT_MICRO = 0x0405,        // }CN L[
        KEYCODE_UNIT_NANO = 0x0406,         // im L[
        KEYCODE_UNIT_PICO = 0x0407,         // sR L[
        KEYCODE_UNIT_FEMTO = 0x0408,        // tFg L[
        KEYCODE_FLOAT_POINT = 0x0800,       // . L[
        KEYCODE_FLOAT_EXP = 0x0801,         // EXP L[
        KEYCODE_PARENTHESIS_LEFT = 0x1000,  // ( L[
        KEYCODE_PARENTHESIS_RIGHT = 0x1001, // ) L[
        KEYCODE_MEMORY_ANS = 0x2000,        // ANS L[
        KEYCODE_OPERATOR_PLUS = 0x4000,     // + L[
        KEYCODE_OPERATOR_MINUS = 0x4001,    // - L[
        KEYCODE_OPERATOR_MUL = 0x4002,      // * L[
        KEYCODE_OPERATOR_DIV = 0x4003,      // / L[
        KEYCODE_OPERATOR_POW = 0x4004,      // ^ L[
        KEYCODE_OPERATOR_FACTORIAL = 0x4005,// ! L[
        KEYCODE_OPERATOR_MOD = 0x4006,      // mod L[
        KEYCODE_OPERATOR_AND = 0x4007,      // and L[
        KEYCODE_OPERATOR_OR = 0x4008,       // or L[
        KEYCODE_OPERATOR_XOR = 0x4009,      // xor L[
        KEYCODE_OPERATOR_NOT = 0x400A,      // not L[
        KEYCODE_OPERATOR_NPR = 0x400B,      // nPr L[
        KEYCODE_OPERATOR_NCR = 0x400C,      // nCr L[
        KEYCODE_OPERATOR_SMUL = 0x400D,     // ł * (p)
        KEYCODE_FUNCTION_SEPARATOR = 0x8000,    // , L[
        KEYCODE_FUNCTION_POW = 0x8001,      // pow ֐L[
        KEYCODE_FUNCTION_EXP = 0x8002,      // exp ֐L[
        KEYCODE_FUNCTION_LN = 0x8003,       // ln ֐L[
        KEYCODE_FUNCTION_LOG = 0x8004,      // log ֐L[
        KEYCODE_FUNCTION_SQRT = 0x8005,     // sqrt ֐L[
        KEYCODE_FUNCTION_CBRT = 0x8006,     // cbrt ֐L[
        KEYCODE_FUNCTION_SIN = 0x8007,      // sin ֐L[
        KEYCODE_FUNCTION_COS = 0x8008,      // cos ֐L[
        KEYCODE_FUNCTION_TAN = 0x8009,      // tan ֐L[
        KEYCODE_FUNCTION_ASIN = 0x800A,     // asin ֐L[
        KEYCODE_FUNCTION_ACOS = 0x800B,     // acos ֐L[
        KEYCODE_FUNCTION_ATAN = 0x800C,     // atan ֐L[
        KEYCODE_FUNCTION_SINH = 0x800D,     // sinh ֐L[
        KEYCODE_FUNCTION_COSH = 0x800E,     // cosh ֐L[
        KEYCODE_FUNCTION_TANH = 0x800F,     // tanh ֐L[
        KEYCODE_FUNCTION_ASINH = 0x8010,    // asinh ֐L[
        KEYCODE_FUNCTION_ACOSH = 0x8011,    // acosh ֐L[
        KEYCODE_FUNCTION_ATANH = 0x8012,    // atanh ֐L[
        KEYCODE_FUNCTION_ABS = 0x8013,      // abs ֐L[
        KEYCODE_FUNCTION_INT = 0x8014,      // int ֐L[
        KEYCODE_FUNCTION_FIX = 0x8015,      // fix ֐L[
        KEYCODE_FUNCTION_GAMMA = 0x8016,    // Gamma ֐L[
        KEYCODE_FUNCTION_FRAC = 0x8017,     // frac ֐L[
        KEYCODE_FUNCTION_JN = 0x8018,       // jn L[
        KEYCODE_FUNCTION_YN = 0x8019        // yn L[
    };
    enum KeyClass {
        KEYCLASS_NONE = 0x0000,         // ނȂ
        KEYCLASS_NUMBER = 0x0100,       // L[
        KEYCLASS_CONSTANT = 0x0200,     // 萔L[
        KEYCLASS_UNIT = 0x0400,         // PʃL[
        KEYCLASS_FLOAT = 0x0800,        // pL[
        KEYCLASS_PARENTHESIS = 0x1000,  // ʃL[
        KEYCLASS_MEMORY = 0x2000,       //  L[
        KEYCLASS_OPERATOR = 0x4000,     // ZqL[
        KEYCLASS_FUNCTION = 0x8000      // ֐L[
    };

private:
    KeyCode _keyCode;       // L[ R[h

public:
    explicit KeyType(Void);
    explicit KeyType(KeyCode code);
    KeyType(KeyTypeConstRef ob);
    KeyTypeConstRef operator=(KeyTypeConstRef ob);
    Void SetKeyCode(KeyCode code);
    KeyCode GetKeyCode(Void) const;
    SFXAnsiString GetString(Void) const;
    SInt16 GetLength(Void) const;
};

inline KeyType::KeyType(Void) : _keyCode(KeyType::KEYCODE_NONE)
{
}

inline KeyType::KeyType(KeyType::KeyCode code) : _keyCode(code)
{
}

inline KeyType::KeyType(KeyTypeConstRef ob) : _keyCode(ob._keyCode)
{
}

inline KeyTypeConstRef KeyType::operator=(KeyTypeConstRef ob)
{
    _keyCode = ob._keyCode;
    return *this;
}

inline Void KeyType::SetKeyCode(KeyType::KeyCode code)
{
    _keyCode = code;
}

inline KeyType::KeyCode KeyType::GetKeyCode(Void) const
{
    return _keyCode;
}

inline SInt16 KeyType::GetLength(Void) const
{
    SFXAnsiString str(GetString());
    return static_cast<SInt16>(str.GetLength());
}


SFMTYPEDEFCLASS(KeySequence)
class KeySequence {
private:
    Array<KeyType> _keys;

public:
    explicit KeySequence(Void);
    KeySequence(KeySequenceConstRef ob);
    KeySequenceConstRef operator=(KeySequenceConstRef ob);
    SFCError Set(KeySequenceConstRef ob);
    SFCError Append(KeyTypeConstRef key);
    Void Remove(SInt32 index);
    Void Clear(Void);
    SFCError Insert(SInt32 index, KeyTypeConstRef key);
    SInt32 GetSize(Void) const;
    KeyTypeConstRef GetKeyType(SInt32 index) const;
    SFCError Normalize(Void);
    SFXAnsiString GetString(Void) const;
    Cursor GetCorrectCursor(SInt16 position) const;
    Cursor GetCorrectCursor(CursorConstRef cursor) const;
    Cursor GetPreviousCursor(SInt16 position) const;
    Cursor GetPreviousCursor(CursorConstRef cursor) const;
    Cursor GetNextCursor(SInt16 position) const;
    Cursor GetNextCursor(CursorConstRef cursor) const;
    SInt32 GetIndex(SInt16 position) const;
    SInt32 GetIndex(CursorConstRef cursor) const;
    Cursor GetCursor(SInt32 index) const;
};

inline KeySequence::KeySequence(Void)
{
}

inline KeySequence::KeySequence(KeySequenceConstRef ob) : _keys(ob._keys)
{
}

inline KeySequenceConstRef KeySequence::operator=(KeySequenceConstRef ob)
{
    _keys = ob._keys;
    return *this;
}

inline SFCError KeySequence::Set(KeySequenceConstRef ob)
{
    return _keys.Set(ob._keys);
}

inline SFCError KeySequence::Append(KeyTypeConstRef key)
{
    return _keys.Append(key);
}

inline Void KeySequence::Remove(SInt32 index)
{
    _keys.Remove(index);
}

inline Void KeySequence::Clear(Void)
{
    _keys.Clear();
}

inline SFCError KeySequence::Insert(SInt32 index, KeyTypeConstRef key)
{
    return _keys.Insert(index, key);
}

inline SInt32 KeySequence::GetSize(Void) const
{
    return _keys.GetSize();
}

inline KeyTypeConstRef KeySequence::GetKeyType(SInt32 index) const
{
    return _keys.Get(index);
}

inline Cursor KeySequence::GetCorrectCursor(CursorConstRef cursor) const
{
    return GetCorrectCursor(cursor.GetPosition());
}

inline Cursor KeySequence::GetPreviousCursor(CursorConstRef cursor) const
{
    return GetPreviousCursor(cursor.GetPosition());
}

inline Cursor KeySequence::GetNextCursor(CursorConstRef cursor) const
{
    return GetNextCursor(cursor.GetPosition());
}

inline SInt32 KeySequence::GetIndex(CursorConstRef cursor) const
{
    return GetIndex(cursor.GetPosition());
}

#endif // __SOPHIACRADLE_KEYSEQUENCE_HPP //
