//
//      MNKeyboard.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.0.
//

#include "MNKeyboard.hpp"
#include "Softkey.hpp"
#include "VNKeyboard.hpp"
#include "VSKeyboard.hpp"
#include "ONKeyboard.hpp"

#define     LABEL_SOFTKEY1      ("I")
#define     LABEL_SOFTKEY3      ("VK")

MNKeyboard::MNKeyboard(SFRApplicationPtr director, SFXRectangleConstRef rect, MonitorPtr monitor, CalculatorPtr calculator) static_throws : Keyboard(director, rect, ATTRIBUTE_MNKEYBOARD, monitor, calculator)
{
    SoftkeyPtr softkey;

    if (static_try()) {
        if ((softkey = Softkey::GetInstance()) != null) {
            static_throw(softkey->Register(this, Softkey::SOFTKEY_1, LABEL_SOFTKEY1));
            if (static_try()) {
                static_throw(softkey->Register(this, Softkey::SOFTKEY_3, LABEL_SOFTKEY3));
            }
        }
        if (static_try()) {
            Refresh();
        }
    }
    return;
}

MNKeyboardPtr MNKeyboard::GetInstance(Void)
{
    return static_cast<MNKeyboardPtr>(Keyboard::GetInstance(ATTRIBUTE_MNKEYBOARD));
}

Void MNKeyboard::HandlerSoftkey1(Void)
{
    SFRApplication::Terminate();
    return;
}

Void MNKeyboard::HandlerSelect(Void)
{
    GetCalculator()->New();
    Apply();
    return;
}

Void MNKeyboard::HandlerClear(Void)
{
    GetCalculator()->Continue();
    Apply();
    return;
}

Void MNKeyboard::HandlerUp(Void)
{
    GetCalculator()->View_left();
    return;
}

Void MNKeyboard::HandlerDown(Void)
{
    GetCalculator()->View_right();
    return;
}

Void MNKeyboard::HandlerLeft(Void)
{
    GetCalculator()->View_left();
    return;
}

Void MNKeyboard::HandlerRight(Void)
{
    GetCalculator()->View_right();
    return;
}

Void MNKeyboard::Handler1(Void)
{
    GetCalculator()->SetNumberType(Calculator::NUMBERTYPE_HEX);
    Refresh();
    return;
}

Void MNKeyboard::Handler2(Void)
{
    GetCalculator()->SetNumberType(Calculator::NUMBERTYPE_DEC);
    Refresh();
    return;
}

Void MNKeyboard::Handler3(Void)
{
    GetCalculator()->SetNumberType(Calculator::NUMBERTYPE_OCT);
    Refresh();
    return;
}

Void MNKeyboard::Handler4(Void)
{
    GetCalculator()->SetNumberType(Calculator::NUMBERTYPE_BIN);
    Refresh();
    return;
}

Void MNKeyboard::Handler7(Void)
{
    switch (GetCalculator()->GetNumberType()) {
        case Calculator::NUMBERTYPE_BIN:
        case Calculator::NUMBERTYPE_OCT:
        case Calculator::NUMBERTYPE_HEX:
            GetCalculator()->SetSignType(Calculator::SIGNTYPE_S);
            break;
        case Calculator::NUMBERTYPE_DEC:
            GetCalculator()->SetAngleType(Calculator::ANGLETYPE_DEG);
            break;
    }
    Refresh();
    return;
}

Void MNKeyboard::Handler8(Void)
{
    switch (GetCalculator()->GetNumberType()) {
        case Calculator::NUMBERTYPE_BIN:
        case Calculator::NUMBERTYPE_OCT:
        case Calculator::NUMBERTYPE_HEX:
            GetCalculator()->SetSignType(Calculator::SIGNTYPE_U);
            break;
        case Calculator::NUMBERTYPE_DEC:
            GetCalculator()->SetAngleType(Calculator::ANGLETYPE_RAD);
            break;
    }
    Refresh();
    return;
}

Void MNKeyboard::Handler9(Void)
{
    switch (GetCalculator()->GetNumberType()) {
        case Calculator::NUMBERTYPE_BIN:
        case Calculator::NUMBERTYPE_OCT:
        case Calculator::NUMBERTYPE_HEX:
            GetCalculator()->SetBitType(Calculator::BITTYPE_64);
            break;
        case Calculator::NUMBERTYPE_DEC:
            GetCalculator()->SetAngleType(Calculator::ANGLETYPE_GRA);
            break;
    }
    Refresh();
    return;
}

Void MNKeyboard::HandlerStar(Void)
{
    switch (GetCalculator()->GetNumberType()) {
        case Calculator::NUMBERTYPE_BIN:
        case Calculator::NUMBERTYPE_OCT:
        case Calculator::NUMBERTYPE_HEX:
            GetCalculator()->SetBitType(Calculator::BITTYPE_32);
            break;
    }
    Refresh();
    return;
}

Void MNKeyboard::Handler0(Void)
{
    switch (GetCalculator()->GetNumberType()) {
        case Calculator::NUMBERTYPE_BIN:
        case Calculator::NUMBERTYPE_OCT:
        case Calculator::NUMBERTYPE_HEX:
            GetCalculator()->SetBitType(Calculator::BITTYPE_16);
            Refresh();
            break;
        case Calculator::NUMBERTYPE_DEC:
            GetCalculator()->View_plus();
            break;
    }
    return;
}

Void MNKeyboard::HandlerPound(Void)
{
    switch (GetCalculator()->GetNumberType()) {
        case Calculator::NUMBERTYPE_BIN:
        case Calculator::NUMBERTYPE_OCT:
        case Calculator::NUMBERTYPE_HEX:
            GetCalculator()->SetBitType(Calculator::BITTYPE_08);
            Refresh();
            break;
        case Calculator::NUMBERTYPE_DEC:
            GetCalculator()->View_minus();
            break;
    }
    return;
}

Void MNKeyboard::Refresh(Void)
{
    static MapRecConst map[] = {
        {{// Bin, S, 08
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec",    COLOR_DIM}, { "Oct",    COLOR_DIM}},
            {{"Bin", COLOR_NORMAL},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S", COLOR_NORMAL}, {   "U",    COLOR_DIM}, {  "64",    COLOR_DIM}},
            {{ "32",    COLOR_DIM}, {  "16",    COLOR_DIM}, {  "08", COLOR_NORMAL}}
        }},
        {{// Bin, S, 16
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec",    COLOR_DIM}, { "Oct",    COLOR_DIM}},
            {{"Bin", COLOR_NORMAL},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S", COLOR_NORMAL}, {   "U",    COLOR_DIM}, {  "64",    COLOR_DIM}},
            {{ "32",    COLOR_DIM}, {  "16", COLOR_NORMAL}, {  "08",    COLOR_DIM}}
        }},
        {{// Bin, S, 32
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec",    COLOR_DIM}, { "Oct",    COLOR_DIM}},
            {{"Bin", COLOR_NORMAL},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S", COLOR_NORMAL}, {   "U",    COLOR_DIM}, {  "64",    COLOR_DIM}},
            {{ "32", COLOR_NORMAL}, {  "16",    COLOR_DIM}, {  "08",    COLOR_DIM}}
        }},
        {{// Bin, S, 64
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec",    COLOR_DIM}, { "Oct",    COLOR_DIM}},
            {{"Bin", COLOR_NORMAL},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S", COLOR_NORMAL}, {   "U",    COLOR_DIM}, {  "64", COLOR_NORMAL}},
            {{ "32",    COLOR_DIM}, {  "16",    COLOR_DIM}, {  "08",    COLOR_DIM}}
        }},
        {{// Bin, U, 08
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec",    COLOR_DIM}, { "Oct",    COLOR_DIM}},
            {{"Bin", COLOR_NORMAL},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S",    COLOR_DIM}, {   "U", COLOR_NORMAL}, {  "64",    COLOR_DIM}},
            {{ "32",    COLOR_DIM}, {  "16",    COLOR_DIM}, {  "08", COLOR_NORMAL}}
        }},
        {{// Bin, U, 16
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec",    COLOR_DIM}, { "Oct",    COLOR_DIM}},
            {{"Bin", COLOR_NORMAL},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S",    COLOR_DIM}, {   "U", COLOR_NORMAL}, {  "64",    COLOR_DIM}},
            {{ "32",    COLOR_DIM}, {  "16", COLOR_NORMAL}, {  "08",    COLOR_DIM}}
        }},
        {{// Bin, U, 32
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec",    COLOR_DIM}, { "Oct",    COLOR_DIM}},
            {{"Bin", COLOR_NORMAL},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S",    COLOR_DIM}, {   "U", COLOR_NORMAL}, {  "64",    COLOR_DIM}},
            {{ "32", COLOR_NORMAL}, {  "16",    COLOR_DIM}, {  "08",    COLOR_DIM}}
        }},
        {{// Bin, U, 64
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec",    COLOR_DIM}, { "Oct",    COLOR_DIM}},
            {{"Bin", COLOR_NORMAL},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S",    COLOR_DIM}, {   "U", COLOR_NORMAL}, {  "64", COLOR_NORMAL}},
            {{ "32",    COLOR_DIM}, {  "16",    COLOR_DIM}, {  "08",    COLOR_DIM}}
        }},
        {{// Oct, S, 08
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec",    COLOR_DIM}, { "Oct", COLOR_NORMAL}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S", COLOR_NORMAL}, {   "U",    COLOR_DIM}, {  "64",    COLOR_DIM}},
            {{ "32",    COLOR_DIM}, {  "16",    COLOR_DIM}, {  "08", COLOR_NORMAL}}
        }},
        {{// Oct, S, 16
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec",    COLOR_DIM}, { "Oct", COLOR_NORMAL}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S", COLOR_NORMAL}, {   "U",    COLOR_DIM}, {  "64",    COLOR_DIM}},
            {{ "32",    COLOR_DIM}, {  "16", COLOR_NORMAL}, {  "08",    COLOR_DIM}}
        }},
        {{// Oct, S, 32
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec",    COLOR_DIM}, { "Oct", COLOR_NORMAL}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S", COLOR_NORMAL}, {   "U",    COLOR_DIM}, {  "64",    COLOR_DIM}},
            {{ "32", COLOR_NORMAL}, {  "16",    COLOR_DIM}, {  "08",    COLOR_DIM}}
        }},
        {{// Oct, S, 64
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec",    COLOR_DIM}, { "Oct", COLOR_NORMAL}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S", COLOR_NORMAL}, {   "U",    COLOR_DIM}, {  "64", COLOR_NORMAL}},
            {{ "32",    COLOR_DIM}, {  "16",    COLOR_DIM}, {  "08",    COLOR_DIM}}
        }},
        {{// Oct, U, 08
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec",    COLOR_DIM}, { "Oct", COLOR_NORMAL}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S",    COLOR_DIM}, {   "U", COLOR_NORMAL}, {  "64",    COLOR_DIM}},
            {{ "32",    COLOR_DIM}, {  "16",    COLOR_DIM}, {  "08", COLOR_NORMAL}}
        }},
        {{// Oct, U, 16
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec",    COLOR_DIM}, { "Oct", COLOR_NORMAL}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S",    COLOR_DIM}, {   "U", COLOR_NORMAL}, {  "64",    COLOR_DIM}},
            {{ "32",    COLOR_DIM}, {  "16", COLOR_NORMAL}, {  "08",    COLOR_DIM}}
        }},
        {{// Oct, U, 32
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec",    COLOR_DIM}, { "Oct", COLOR_NORMAL}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S",    COLOR_DIM}, {   "U", COLOR_NORMAL}, {  "64",    COLOR_DIM}},
            {{ "32", COLOR_NORMAL}, {  "16",    COLOR_DIM}, {  "08",    COLOR_DIM}}
        }},
        {{// Oct, U, 64
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec",    COLOR_DIM}, { "Oct", COLOR_NORMAL}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S",    COLOR_DIM}, {   "U", COLOR_NORMAL}, {  "64", COLOR_NORMAL}},
            {{ "32",    COLOR_DIM}, {  "16",    COLOR_DIM}, {  "08",    COLOR_DIM}}
        }},
        {{// Dec, Deg
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec", COLOR_NORMAL}, { "Oct",    COLOR_DIM}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{"Deg", COLOR_NORMAL}, { "Rad",    COLOR_DIM}, { "Gra",    COLOR_DIM}},
            {        MAP_UNDEFINED, {"UNT+",   COLOR_MODE}, {"UNT-",   COLOR_MODE}}
        }},
        {{// Dec, Rad
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec", COLOR_NORMAL}, { "Oct",    COLOR_DIM}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{"Deg",    COLOR_DIM}, { "Rad", COLOR_NORMAL}, { "Gra",    COLOR_DIM}},
            {        MAP_UNDEFINED, {"UNT+",   COLOR_MODE}, {"UNT-",   COLOR_MODE}}
        }},
        {{// Dec, Gra
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex",    COLOR_DIM}, { "Dec", COLOR_NORMAL}, { "Oct",    COLOR_DIM}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{"Deg",    COLOR_DIM}, { "Rad",    COLOR_DIM}, { "Gra", COLOR_NORMAL}},
            {        MAP_UNDEFINED, {"UNT+",   COLOR_MODE}, {"UNT-",   COLOR_MODE}}
        }},
        {{// Hex, S, 08
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex", COLOR_NORMAL}, { "Dec",    COLOR_DIM}, { "Oct",    COLOR_DIM}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S", COLOR_NORMAL}, {   "U",    COLOR_DIM}, {  "64",    COLOR_DIM}},
            {{ "32",    COLOR_DIM}, {  "16",    COLOR_DIM}, {  "08", COLOR_NORMAL}}
        }},
        {{// Hex, S, 16
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex", COLOR_NORMAL}, { "Dec",    COLOR_DIM}, { "Oct",    COLOR_DIM}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S", COLOR_NORMAL}, {   "U",    COLOR_DIM}, {  "64",    COLOR_DIM}},
            {{ "32",    COLOR_DIM}, {  "16", COLOR_NORMAL}, {  "08",    COLOR_DIM}}
        }},
        {{// Hex, S, 32
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex", COLOR_NORMAL}, { "Dec",    COLOR_DIM}, { "Oct",    COLOR_DIM}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S", COLOR_NORMAL}, {   "U",    COLOR_DIM}, {  "64",    COLOR_DIM}},
            {{ "32", COLOR_NORMAL}, {  "16",    COLOR_DIM}, {  "08",    COLOR_DIM}}
        }},
        {{// Hex, S, 64
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex", COLOR_NORMAL}, { "Dec",    COLOR_DIM}, { "Oct",    COLOR_DIM}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S", COLOR_NORMAL}, {   "U",    COLOR_DIM}, {  "64", COLOR_NORMAL}},
            {{ "32",    COLOR_DIM}, {  "16",    COLOR_DIM}, {  "08",    COLOR_DIM}}
        }},
        {{// Hex, U, 08
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex", COLOR_NORMAL}, { "Dec",    COLOR_DIM}, { "Oct",    COLOR_DIM}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S",    COLOR_DIM}, {   "U", COLOR_NORMAL}, {  "64",    COLOR_DIM}},
            {{ "32",    COLOR_DIM}, {  "16",    COLOR_DIM}, {  "08", COLOR_NORMAL}}
        }},
        {{// Hex, U, 16
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex", COLOR_NORMAL}, { "Dec",    COLOR_DIM}, { "Oct",    COLOR_DIM}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S",    COLOR_DIM}, {   "U", COLOR_NORMAL}, {  "64",    COLOR_DIM}},
            {{ "32",    COLOR_DIM}, {  "16", COLOR_NORMAL}, {  "08",    COLOR_DIM}}
        }},
        {{// Hex, U, 32
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex", COLOR_NORMAL}, { "Dec",    COLOR_DIM}, { "Oct",    COLOR_DIM}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S",    COLOR_DIM}, {   "U", COLOR_NORMAL}, {  "64",    COLOR_DIM}},
            {{ "32", COLOR_NORMAL}, {  "16",    COLOR_DIM}, {  "08",    COLOR_DIM}}
        }},
        {{// Hex, U, 64
            {        MAP_UNDEFINED,                MAP_CNT,                MAP_OFF},
            {{"Hex", COLOR_NORMAL}, { "Dec",    COLOR_DIM}, { "Oct",    COLOR_DIM}},
            {{"Bin",    COLOR_DIM},          MAP_UNDEFINED,          MAP_UNDEFINED},
            {{  "S",    COLOR_DIM}, {   "U", COLOR_NORMAL}, {  "64", COLOR_NORMAL}},
            {{ "32",    COLOR_DIM}, {  "16",    COLOR_DIM}, {  "08",    COLOR_DIM}}
        }}
    };
    static SInt16Const index[Calculator::NUMBERTYPE_LIMIT][Calculator::SIGNTYPE_LIMIT][Calculator::BITTYPE_LIMIT][Calculator::ANGLETYPE_LIMIT] = {
        {{{ 0,  0,  0}, { 1,  1,  1}, { 2,  2,  2}, { 3,  3,  3}}, {{ 4,  4,  4}, { 5,  5,  5}, { 6,  6,  6}, { 7,  7,  7}}},
        {{{ 8,  8,  8}, { 9,  9,  9}, {10, 10, 10}, {11, 11, 11}}, {{12, 12, 12}, {13, 13, 13}, {14, 14, 14}, {15, 15, 15}}},
        {{{16, 17, 18}, {16, 17, 18}, {16, 17, 18}, {16, 17, 18}}, {{16, 17, 18}, {16, 17, 18}, {16, 17, 18}, {16, 17, 18}}},
        {{{19, 19, 19}, {20, 20, 20}, {21, 21, 21}, {22, 22, 22}}, {{23, 23, 23}, {24, 24, 24}, {25, 25, 25}, {26, 26, 26}}}
    };

    Keyboard::Refresh(map[index[GetCalculator()->GetNumberType()][GetCalculator()->GetSignType()][GetCalculator()->GetBitType()][GetCalculator()->GetAngleType()]]);
    return;
}

Void MNKeyboard::Activate(KeyboardPtr inactivate)
{
    Keyboard::Activate(inactivate, Monitor::MODE_NONE);
    return;
}

Void MNKeyboard::Apply(Void)
{
    KeyboardPtr keyboard;

    if ((keyboard = ONKeyboard::GetInstance()) != null) {
        keyboard->Refresh();
    }
    if ((keyboard = VSKeyboard::GetInstance()) != null) {
        keyboard->Refresh();
    }
    if ((keyboard = VNKeyboard::GetInstance()) != null) {
        keyboard->Refresh();
        keyboard->Activate(this);
    }
    return;
}
