//
//      ONKeyboard.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.0.
//

#include "ONKeyboard.hpp"
#include "FNKeyboard.hpp"

ONKeyboard::ONKeyboard(SFRApplicationPtr director, SFXRectangleConstRef rect, MonitorPtr monitor, CalculatorPtr calculator) static_throws : Keyboard(director, rect, ATTRIBUTE_ONKEYBOARD, monitor, calculator)
{
    if (static_try()) {
        Refresh();
    }
    return;
}

ONKeyboardPtr ONKeyboard::GetInstance(Void)
{
    return static_cast<ONKeyboardPtr>(Keyboard::GetInstance(ATTRIBUTE_ONKEYBOARD));
}

Void ONKeyboard::HandlerClear(Void)
{
    Return();
    return;
}

Void ONKeyboard::Handler1(Void)
{
    GetCalculator()->Operator_not();
    Return();
    return;
}

Void ONKeyboard::Handler2(Void)
{
    GetCalculator()->Operator_add();
    Return();
    return;
}

Void ONKeyboard::Handler3(Void)
{
    GetCalculator()->Operator_and();
    Return();
    return;
}

Void ONKeyboard::Handler4(Void)
{
    GetCalculator()->Operator_mul();
    Return();
    return;
}

Void ONKeyboard::Handler5(Void)
{
    GetCalculator()->Operator_mod();
    Return();
    return;
}

Void ONKeyboard::Handler6(Void)
{
    GetCalculator()->Operator_div();
    Return();
    return;
}

Void ONKeyboard::Handler7(Void)
{
    GetCalculator()->Operator_ior();
    Return();
    return;
}

Void ONKeyboard::Handler8(Void)
{
    GetCalculator()->Operator_sub();
    Return();
    return;
}

Void ONKeyboard::Handler9(Void)
{
    GetCalculator()->Operator_xor();
    Return();
    return;
}

Void ONKeyboard::HandlerStar(Void)
{
    Return();
    return;
}

Void ONKeyboard::Handler0(Void)
{
    GetCalculator()->Operator_comma();
    Return();
    return;
}

Void ONKeyboard::HandlerPound(Void)
{
    KeyboardPtr keyboard;

    if ((keyboard = FNKeyboard::GetInstance()) != null) {
        keyboard->Activate(this);
    }
    return;
}

Void ONKeyboard::Refresh(Void)
{
    static MapRecConst map[] = {
        {{// 02
            {        MAP_UNDEFINED,                MAP_RTN,               MAP_OFF},
            {{"not", COLOR_NORMAL}, {  "+",  COLOR_NORMAL}, {"and", COLOR_NORMAL}},
            {{  "*", COLOR_NORMAL}, {"mod",  COLOR_NORMAL}, {  "/", COLOR_NORMAL}},
            {{"ior", COLOR_NORMAL}, {  "-",  COLOR_NORMAL}, {"xor", COLOR_NORMAL}},
            {              MAP_VAL,          MAP_UNDEFINED,         MAP_UNDEFINED}
        }},
        {{// 08
            {        MAP_UNDEFINED,                MAP_RTN,               MAP_OFF},
            {{"not", COLOR_NORMAL}, {  "+",  COLOR_NORMAL}, {"and", COLOR_NORMAL}},
            {{  "*", COLOR_NORMAL}, {"mod",  COLOR_NORMAL}, {  "/", COLOR_NORMAL}},
            {{"ior", COLOR_NORMAL}, {  "-",  COLOR_NORMAL}, {"xor", COLOR_NORMAL}},
            {              MAP_VAL,          MAP_UNDEFINED,         MAP_UNDEFINED}
        }},
        {{// 10
            {        MAP_UNDEFINED,                MAP_RTN,               MAP_OFF},
            {        MAP_UNDEFINED, {  "+",  COLOR_NORMAL},         MAP_UNDEFINED},
            {{  "*", COLOR_NORMAL}, {"mod",  COLOR_NORMAL}, {  "/", COLOR_NORMAL}},
            {        MAP_UNDEFINED, {  "-",  COLOR_NORMAL},         MAP_UNDEFINED},
            {              MAP_VAL, {  ",",  COLOR_NORMAL},               MAP_FNC}
        }},
        {{// 16
            {        MAP_UNDEFINED,                MAP_RTN,               MAP_OFF},
            {{"not", COLOR_NORMAL}, {  "+",  COLOR_NORMAL}, {"and", COLOR_NORMAL}},
            {{  "*", COLOR_NORMAL}, {"mod",  COLOR_NORMAL}, {  "/", COLOR_NORMAL}},
            {{"ior", COLOR_NORMAL}, {  "-",  COLOR_NORMAL}, {"xor", COLOR_NORMAL}},
            {              MAP_VAL,          MAP_UNDEFINED,         MAP_UNDEFINED}
        }}
    };

    Keyboard::Refresh(map[GetCalculator()->GetNumberType()]);
    return;
}

Void ONKeyboard::Activate(KeyboardPtr inactivate)
{
    Keyboard::Activate(inactivate, Monitor::MODE_OPERATOR);
    return;
}
