//
//      Softkey.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.0.
//

#include "Softkey.hpp"

#define     MINIMUM_HEIGHT      (12)
#define     BASE_MARGIN         (2)
#define     RING_MARGIN         (3)
#define     RING_SIZE           (1)
#define     FONT_MARGIN         (1)

Softkey::Softkey(SFRApplicationPtr director) static_throws : SFRPlainWindow(director, SFXRectangle(0, 0, 0, 0), BEHAVIOR_SFRPLAINWINDOW, ATTRIBUTE_SOFTKEY), _bind(null)
{
    SFXRectangle rect;
    SInt16 height;

    if (static_try()) {
#if TARGET_VERSION_GT(3, 1, 0)
        static_throw(director->RegisterTracer(SFEVT_KEY, SFEVT_KEY_RELEASE, AVK_SOFT1, AVK_SOFT3, BEHAVIOR_NONE, TRACER_FORWARD));
#else
        static_throw(director->RegisterTracer(SFEVT_KEY, SFEVT_KEY_HELD, AVK_SOFT1, AVK_SOFT3, BEHAVIOR_NONE, TRACER_FORWARD));
#endif
        if (static_try()) {
            static_throw(director->RegisterTracer(static_cast<SFCEventEnum>(USEREVT_SOFTKEY), BEHAVIOR_NONE, TRACER_NONE));
            if (static_try()) {
                static_throw(RegisterHandler(SREVT_RESPONDER_RENDER, SRP16_RENDER_CONTENT, HANDLER_BEFORE, HANDLER_FUNCTION(OnRender)));
                if (static_try()) {
#if TARGET_VERSION_GT(3, 1, 0)
                    static_throw(RegisterHandler(SFEVT_KEY, SFEVT_KEY_RELEASE, AVK_SOFT1, AVK_SOFT3, HANDLER_AFTER, HANDLER_NULL));
#else
                    static_throw(RegisterHandler(SFEVT_KEY, SFEVT_KEY_HELD, AVK_SOFT1, AVK_SOFT3, HANDLER_AFTER, HANDLER_NULL));
#endif
                    if (static_try()) {
                        static_throw(RegisterHandler(SFEVT_KEY, AVK_SOFT1, AVK_SOFT3, HANDLER_AFTER, HANDLER_FUNCTION(OnSoftkey)));
                        if (static_try()) {
                            rect = director->GetContentWorld();
                            height = SFXGraphics::GetFontHeight(AEE_FONT_NORMAL) - FONT_MARGIN;
                            if (height < MINIMUM_HEIGHT) {
                                height = MINIMUM_HEIGHT;
                            }
                            height += (BASE_MARGIN + RING_MARGIN) * 2;
                            rect.SetTop(rect.GetBottom() - height);
                            SetBaseBound(rect);
                        }
                    }
                }
            }
        }
    }
    return;
}

Softkey::~Softkey(Void)
{
    SFXList<ItemRecPtr>::Enumerator it(_item.GetFirstEnumerator());

    if (it.IsValid()) {
        while (it.HasNext()) {
            ::delete it.GetNext();
        }
    }
    return;
}

SoftkeyPtr Softkey::GetInstance(Void)
{
    return static_cast<SoftkeyPtr>(SFRApplication::GetInstance()->GetFront(TYPE_SFRWINDOW, ATTRIBUTE_SOFTKEY, BEHAVIOR_NONE));
}

SFRResponderPtr Softkey::Bind(SFRResponderPtr responder)
{
    SFRResponderPtr result(_bind);

    if (responder != _bind) {
        _bind = responder;
        InvalidateContent();
    }
    return result;
}

SFCError Softkey::Register(SFRResponderPtr responder, SoftkeyEnum index, SFXWideStringConstRef label, Bool enable)
{
    ItemRecPtr item;
    SInt16 i;
    SFCError error(SFERR_NO_ERROR);

    if (0 <= index && index < SOFTKEY_LIMIT) {
        if ((item = Find(responder)) != null) {
            item->label[index] = label;
            item->enable[index] = enable;
            InvalidateContent();
        }
        else if ((item = ::new ItemRec) != null) {
            item->responder = responder;
            for (i = 0; i < SOFTKEY_LIMIT; ++i) {
                item->label[i] = "";
                item->enable[i] = false;
            }
            item->label[index] = label;
            item->enable[index] = enable;
            if (_item.Append(item) == SFERR_NO_ERROR) {
                InvalidateContent();
            }
            else {
                error = SFERR_NO_MEMORY;
                ::delete item;
            }
        }
        else {
            error = SFERR_NO_MEMORY;
        }
    }
    else {
        error = SFERR_INVALID_PARAM;
    }
    return error;
}

Void Softkey::Unregister(SFRResponderPtr responder)
{
    SFXList<ItemRecPtr>::Iterator it(_item.GetFirstIterator());
    ItemRecPtr temp;

    if (it.IsValid()) {
        while (it.HasNext()) {
            temp = it.GetNext();
            if (temp->responder == responder) {
                it.Remove();
                ::delete temp;
                if (responder == _bind) {
                    _bind = null;
                }
                InvalidateContent();
                break;
            }
        }
    }
    return;
}

Void Softkey::Initialize(SFRResponderPtr responder)
{
    responder->SetReference(responder);
    return;
}

Void Softkey::Terminate(SFRResponderPtr responder)
{
    SoftkeyPtr softkey;

    if ((softkey = GetInstance()) != null) {
        if (responder->GetReference() != responder) {
            softkey->Bind(static_cast<SFRResponderPtr>(responder->GetReference()));
        }
        softkey->Unregister(responder);
    }
    return;
}

HANDLER_IMPLEMENT_VOIDRENDER(Softkey, OnRender, graphics)
{
    static SFXBevelColor::AtomRecConst theme[] = {
        {
            {0x00, 0xFF, 0xFF, 0xFF},
            {0x00, 0xAA, 0xAA, 0xAA},
            {0x00, 0x22, 0x22, 0x22}
        },
        {
            {0x00, 0xDD, 0xDD, 0xDD},
            {0x00, 0xAA, 0xAA, 0xAA},
            {0x00, 0x44, 0x44, 0x44}
        },
        {
            {0x00, 0xCC, 0xCC, 0xCC},
            {0x00, 0xAA, 0xAA, 0xAA},
            {0x00, 0x77, 0x77, 0x77}
        }
    };
    SFXRectangle rect(GetContentWorld());
    SFXRectangle temp;
    ItemRecPtr item;
    SInt16 width;

    graphics->DrawBevelVertical(rect, theme[0]);
    rect.Deflate(1, 0);
    graphics->DrawBevelVertical(rect, theme[1]);
    rect.Deflate(1, 0);
    graphics->FillBevelVertical(rect, theme[2]);
    rect.Deflate(1, 0);
    if ((item = Find(_bind)) != null) {
        width = (rect.GetWidth() - BASE_MARGIN * (SOFTKEY_LIMIT + 1)) / SOFTKEY_LIMIT + BASE_MARGIN * 2;
        if (item->enable[SOFTKEY_1]) {
            temp = rect;
            temp.SubRight(temp.GetWidth() - width);
            DrawButton(graphics, temp, item->label[SOFTKEY_1]);
        }
        if (item->enable[SOFTKEY_3]) {
            temp = rect;
            temp.Deflate(width - BASE_MARGIN, 0);
            DrawButton(graphics, temp, item->label[SOFTKEY_3]);
        }
        if (item->enable[SOFTKEY_2]) {
            temp = rect;
            temp.AddLeft(temp.GetWidth() - width);
            DrawButton(graphics, temp, item->label[SOFTKEY_2]);
        }
    }
    return;
}

HANDLER_IMPLEMENT_BOOLEVENT(Softkey, OnSoftkey, event)
{
    SFRResponderPtr front;
    ItemRecPtr item;
    Bool result(false);

    if ((front = GetDirector()->GetFront()) != null) {
        if (front->GetAttribute() != ATTRIBUTE_SFRCOMBOBOXMENU) {
            if ((item = Find(_bind)) != null) {
                switch (event.GetP16()) {
                    case AVK_SOFT1:
                        if (item->enable[SOFTKEY_1]) {
                            result = _bind->Invoke(SFXEvent(static_cast<SFCEventEnum>(USEREVT_SOFTKEY), SOFTKEY_1, 0));
                        }
                        break;
                    case AVK_SOFT2:
                        if (item->enable[SOFTKEY_2]) {
                            result = _bind->Invoke(SFXEvent(static_cast<SFCEventEnum>(USEREVT_SOFTKEY), SOFTKEY_2, 0));
                        }
                        break;
                    case AVK_SOFT3:
                        if (item->enable[SOFTKEY_3]) {
                            result = _bind->Invoke(SFXEvent(static_cast<SFCEventEnum>(USEREVT_SOFTKEY), SOFTKEY_3, 0));
                        }
                        break;
                }
            }
        }
    }
    return result;
}

Void Softkey::DrawButton(SFXGraphicsPtr graphics, SFXRectangleConstRef rect, SFXWideStringConstRef string)
{
    static SFXRGBColor::AtomRecConst theme[] = {
        {0x00, 0x77, 0x77, 0x77},
        {0x00, 0x66, 0x66, 0x66},
        {0x00, 0xDD, 0xDD, 0xDD},
        {0x00, 0xFF, 0xFF, 0xFF}
    };
    SFXRectangle temp(rect);

    temp.Deflate(BASE_MARGIN, BASE_MARGIN);
    graphics->DrawRoundRectangle(temp, SFXSize(9, 9), theme[0]);
    temp.Deflate(RING_SIZE, RING_SIZE);
    graphics->FillRoundRectangle(temp, SFXSize(7, 7), theme[1]);
    graphics->DrawRoundRectangle(temp, SFXSize(7, 7), theme[2]);
    temp.Deflate(RING_SIZE, RING_SIZE);
    temp.AddY(FONT_MARGIN);
    graphics->DrawText(string, temp, theme[3]);
    return;
}

Softkey::ItemRecPtr Softkey::Find(SFRResponderPtr responder) const
{
    SFXList<ItemRecPtr>::Enumerator it(_item.GetFirstEnumerator());
    ItemRecPtr temp;
    ItemRecPtr result(null);

    if (it.IsValid()) {
        while (it.HasNext()) {
            temp = it.GetNext();
            if (temp->responder == responder) {
                result = temp;
                break;
            }
        }
    }
    return result;
}
