//
//      Stack.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.0.
//

#ifndef __SOPHIACRADLE_STACK_HPP
#define __SOPHIACRADLE_STACK_HPP

#include <SophiaFramework.hpp>

template <typename T>
class Stack {
    private:
        SFXStack<T*> _stack;

    public:
        explicit Stack(Void);
        explicit Stack(const Stack<T> &stack);
        explicit Stack(UInt16 threshold, UInt16 cluster);
        virtual ~Stack(Void);
        const Stack<T> &operator=(const Stack<T> &stack);
        virtual Void Clear(Void);
        SFCError Push(const T &element);
        T Pop(Void);
        SInt32 GetSize(Void) const;
        virtual SFCError Set(const Stack<T> &stack);
        const T &GetLast(Void) const;
};

template <typename T>
inline Stack<T>::Stack(Void)
{
    return;
}

template <typename T>
inline Stack<T>::Stack(UInt16 threshold, UInt16 cluster) : _stack(threshold, cluster)
{
    return;
}

template <typename T>
inline Stack<T>::Stack(const Stack<T> &stack) : _stack(stack.GetThreshold(), stack.GetCluster())
{
    Set(stack);
    return;
}

template <typename T>
inline Stack<T>::~Stack(Void)
{
    Clear();
    return;
}

template <typename T>
inline const Stack<T> &Stack<T>::operator=(const Stack<T> &stack)
{
    Set(stack);
    return *this;
}

template <typename T>
inline Void Stack<T>::Clear(Void)
{
    while (_stack.GetSize() > 0) {
        ::delete _stack.Pop();
    }
    return;
}

template <typename T>
inline SFCError Stack<T>::Push(const T &element)
{
    SFCError result(SFERR_NO_ERROR);
    T* p;

    if ((p = ::new T(element)) != null) {
        if ((result = _stack.Push(p)) != SFERR_NO_ERROR) {
            ::delete p;
        }
    }
    else {
        result = SFERR_NO_MEMORY;
    }
    return result;
}

template <typename T>
inline T Stack<T>::Pop(Void)
{
    ASSERT(GetSize() > 0);

    T* p = _stack.Pop();
    T ret(*p);

    ::delete p;
    return ret;
}

template <typename T>
inline SInt32 Stack<T>::GetSize(Void) const
{
    return _stack.GetSize();
}

template <typename T>
inline SFCError Stack<T>::Set(const Stack<T> &stack)
{
    Clear();

    SInt32Const size(stack.GetSize());
    SFCError result(SFERR_NO_ERROR);
    SInt32 i;

    for (i = 0; i < size; ++i) {
        if ((result = Push(*(stack._stack.Get(i)))) != SFERR_NO_ERROR) {
            break;
        }
    }
    return result;
}

template <typename T>
inline const T &Stack<T>::GetLast(Void) const
{
    ASSERT(GetSize() > 0);

    return *(_stack.GetLast());
}

#endif // __SOPHIACRADLE_STACK_HPP //
